



proc define-QUADRATURE {w} {
  global resource mname IPslot IPslots

  set mname IPQUADRATURE#$w
  set slot  [lsearch $IPslots $IPslot($mname)]

  log "deleting all IP-QUADRATURE#$w registers"
  EG "register :pattern '/$resource/$mname.*' !delete"

#     ID
      define-register xIP ManID        "-s $slot -o 0x09 -d id -p ro -w 8 -zx"
      define-register xIP ModID        "-s $slot -o 0x0b -d id -p ro -w 8 -zx"

      define-register xIP CSR          "-s $slot -o 0x31 -d io -p rw -w 8 -zx"

#     Counter 1
      define-register xIP Ch1.Counter  "-s $slot -o 0x01 -d io -p ro -w 8 -zx"
      define-register xIP Ch1.PCR      "-s $slot -o 0x01 -d io -p wo -w 8 -zx"
      define-register xIP Ch1.Status   "-s $slot -o 0x03 -d io -p ro -w 8 -zx"
      define-register xIP Ch1.Control  "-s $slot -o 0x03 -d io -p wo -w 8 -zx"
      define-register xIP Ch1.ICR      "-s $slot -o 0x03 -d io -p wo -w 8 -zx"
      define-register xIP Ch1.OCR      "-s $slot -o 0x03 -d io -p wo -w 8 -zx"
      define-register xIP Ch1.QR       "-s $slot -o 0x03 -d io -p wo -w 8 -zx"
      define-register xIP Ch1.CHCR     "-s $slot -o 0x21 -d io -p rw -w 8 -zx"

#     Counter 2
      define-register xIP Ch2.Counter  "-s $slot -o 0x05 -d io -p ro -w 8 -zx"
      define-register xIP Ch2.PCR      "-s $slot -o 0x05 -d io -p wo -w 8 -zx"
      define-register xIP Ch2.Status   "-s $slot -o 0x07 -d io -p ro -w 8 -zx"
      define-register xIP Ch2.Control  "-s $slot -o 0x07 -d io -p wo -w 8 -zx"
      define-register xIP Ch2.ICR      "-s $slot -o 0x07 -d io -p wo -w 8 -zx"
      define-register xIP Ch2.OCR      "-s $slot -o 0x07 -d io -p wo -w 8 -zx"
      define-register xIP Ch2.QR       "-s $slot -o 0x07 -d io -p wo -w 8 -zx"
      define-register xIP Ch2.CHCR     "-s $slot -o 0x25 -d io -p rw -w 8 -zx"

#     Counters 3
      define-register xIP Ch3.Counter  "-s $slot -o 0x09 -d io -p ro -w 8 -zx"
      define-register xIP Ch3.PCR      "-s $slot -o 0x09 -d io -p wo -w 8 -zx"
      define-register xIP Ch3.Status   "-s $slot -o 0x0b -d io -p ro -w 8 -zx"
      define-register xIP Ch3.Control  "-s $slot -o 0x0b -d io -p wo -w 8 -zx"
      define-register xIP Ch3.ICR      "-s $slot -o 0x0b -d io -p wo -w 8 -zx"
      define-register xIP Ch3.OCR      "-s $slot -o 0x0b -d io -p wo -w 8 -zx"
      define-register xIP Ch3.QR       "-s $slot -o 0x0b -d io -p wo -w 8 -zx"
      define-register xIP Ch3.CHCR     "-s $slot -o 0x29 -d io -p rw -w 8 -zx"

#     Counters 4
      define-register xIP Ch4.Counter  "-s $slot -o 0x0d -d io -p ro -w 8 -zx"
      define-register xIP Ch4.PCR      "-s $slot -o 0x0d -d io -p wo -w 8 -zx"
      define-register xIP Ch4.Status   "-s $slot -o 0x0f -d io -p ro -w 8 -zx"
      define-register xIP Ch4.Control  "-s $slot -o 0x0f -d io -p wo -w 8 -zx"
      define-register xIP Ch4.ICR      "-s $slot -o 0x0f -d io -p wo -w 8 -zx"
      define-register xIP Ch4.OCR      "-s $slot -o 0x0f -d io -p wo -w 8 -zx"
      define-register xIP Ch4.QR       "-s $slot -o 0x0f -d io -p wo -w 8 -zx"
      define-register xIP Ch4.CHCR     "-s $slot -o 0x2d -d io -p rw -w 8 -zx"

}


proc read-QUAD-SR {c} {return [expr [read-register Ch$c.Status] & 0x1f]}

proc write-QUAD-CR {c v} {write-register Ch$c.Control [expr $v & 0x3f]}

proc write-QUAD-ICR {c v} {write-register Ch$c.ICR [expr ($v & 0x3f) | 0x40]}

proc write-QUAD-OCR {c v} {write-register Ch$c.OCR [expr ($v & 0x3f) | 0x80]}

proc write-QUAD-QR {c v} {write-register Ch$c.QR [expr ($v & 0x3f) | 0xc0]}

proc write-QUAD-CHCR {c v} {write-register Ch$c.CHCR [expr ($v & 0x9f) | 0x20]}

proc read-QUAD-CHCR {c} {return [expr [read-register Ch$c.CHCR] & 0xdf]}

proc read-QUAD-CSR {} {return [expr [read-register CSR] & 0x03]}

proc write-QUAD-CSR {v} {write-register CSR [expr ($v & 0x03) | 0xf8]}
